## ns3 3.42

=== ns-3.42/CMakeLists.txt ===
# ##############################################################################
# Required CMake version            #
# ##############################################################################
cmake_minimum_required(VERSION 3.13..3.13)

# ##############################################################################
# Project name                        #
# ##############################################################################
project(NS3 CXX C)

file(STRINGS VERSION NS3_VER)

# minimum compiler versions
set(AppleClang_MinVersion 11.0.0)
set(Clang_MinVersion 10.0.0)
set(GNU_MinVersion 9.1.0)

# common options
option(NS3_ASSERT "Enable assert on failure" OFF)
option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
option(NS3_EXAMPLES "Enable examples to be built" OFF)
option(NS3_LOG "Enable logging to be built" OFF)
option(NS3_TESTS "Enable tests to be built" OFF)

# fd-net-device options
option(NS3_EMU "Build with emulation support" ON)
option(NS3_TAP "Build with Tap support" ON)
option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)

# maintenance and documentation
option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
option(NS3_CLANG_TIMETRACE
       "Collect compilation statistics to analyze the build process" OFF
)
option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
option(NS3_COVERAGE "Enable code coverage measurements and report generation"
       OFF
)
option(NS3_COVERAGE_ZERO_COUNTERS
       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
)
option(NS3_INCLUDE_WHAT_YOU_USE
       "Use IWYU to determine unnecessary headers included" OFF
)
option(NS3_LINK_WHAT_YOU_USE
       "Use LWYU to determine unnecessary linked libraries" OFF
)
option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)

# 3rd-party libraries/programs
option(NS3_NETANIM "Build netanim" OFF)

# other options
option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
option(NS3_CPM "Enable the CPM C++ library manager support" OFF)
option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
option(NS3_FETCH_OPTIONAL_COMPONENTS
       "Fetch Brite, Click and Openflow dependencies" OFF
)
option(NS3_GSL "Build with GSL support" ON)
option(NS3_GTK3 "Build with GTK3 support" ON)
option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
option(NS3_MONOLIB
       "Build a single shared ns-3 library and link it against executables" OFF
)
option(NS3_MPI "Build with MPI support" OFF)
option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
option(
  NS3_NINJA_TRACING
  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
  OFF
)
set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
option(NS3_PRECOMPILE_HEADERS
       "Precompile module headers to speed up compilation" ON
)
option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
option(NS3_SQLITE "Build with SQLite support" ON)
option(NS3_EIGEN "Build with Eigen support" ON)
option(NS3_STATIC "Build a static ns-3 library and link it against executables"
       OFF
)
option(NS3_VCPKG "Enable the Vcpkg C++ library manager support" OFF)
option(NS3_VERBOSE "Print additional build system messages" OFF)
option(NS3_VISUALIZER "Build visualizer module" ON)
option(NS3_WARNINGS "Enable compiler warnings" ON)
option(NS3_WARNINGS_AS_ERRORS
       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
)

# Options that either select which modules will get built or disable modules
set(NS3_ENABLED_MODULES ""
    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
)
set(NS3_DISABLED_MODULES "" CACHE STRING
                                  "List of modules to disable (e.g. lte;wimax)"
)

# Filter in the modules from which examples and tests will be built
set(NS3_FILTER_MODULE_EXAMPLES_AND_TESTS
    ""
    CACHE
      STRING
      "List of modules that should have their examples and tests built (e.g. lte;wifi)"
)

# Include macros used below
include(build-support/macros-and-definitions.cmake)

# Scan module libraries
subdirlist(libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/src)

# Scan contribution libraries
subdirlist(contrib_libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/contrib)

# Before filtering, we need to load settings from .ns3rc
parse_ns3rc(
  ns3rc_enabled_modules ns3rc_disabled_modules ns3rc_examples_enabled
  ns3rc_tests_enabled
)

# After scanning modules, we can filter enabled and disabled ones
filter_enabled_and_disabled_modules(
  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
  ns3rc_enabled_modules ns3rc_disabled_modules
)

if(${NS3_CCACHE})
  # Use ccache if available
  mark_as_advanced(CCACHE)
  find_program(CCACHE ccache)
  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
    message(STATUS "CCache is enabled.")
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    execute_process(
      COMMAND
        ${CCACHE} --set-config
        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
    )
  endif()
endif()

# ##############################################################################
# Process options                     #
# ##############################################################################
process_options()

# ##############################################################################
# Add subdirectories                  #
# ##############################################################################
# Build NS3 library core
add_subdirectory(src)

# Build NS library examples
add_subdirectory(examples)

# Build scratch/simulation scripts
add_subdirectory(scratch)

# Build test utils
add_subdirectory(utils)

write_lock()
write_configtable()

# Export package targets when installing
ns3_cmake_package()

=== ns-3.42/src/CMakeLists.txt ===
set(libs "${libs_to_build}")

# Process the visualizer module first if enabled
if(visualizer IN_LIST libs)
  if(${ENABLE_VISUALIZER})
    message(STATUS "Processing src/visualizer")
    add_subdirectory(visualizer)
  endif()
  list(REMOVE_ITEM libs visualizer)
endif()

# Process subdirectories
foreach(libname ${libs})
  if(EXISTS ${PROJECT_SOURCE_DIR}/src/${libname}/CMakeLists.txt)
    message(STATUS "Processing src/${libname}")
    add_subdirectory(${libname})
  else()
    message(${HIGHLIGHTED_STATUS}
            "Skipping src/${libname}: it does not contain a CMakeLists.txt file"
    )
  endif()
endforeach()

# Scan for disabled modules that define settings prefixed with NS3_ or ENABLE_
# so that we can initialize them as turned off (setting as temporary variables
# not to affect the cached variables that are set when normally processed)
subdirlist(modules ${CMAKE_CURRENT_SOURCE_DIR})
foreach(libname ${modules})
  if(NOT (${libname} IN_LIST libs))
    # Skip module directories without CMakeLists.txt files
    if(NOT (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt))
      continue()
    endif()

    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt
         lib_cmakelists_contents
    )
    string(REGEX MATCHALL "(NS3_[a-zA-Z0-9_]*)|(ENABLE_[a-zA-Z0-9_]*)" flags
                 "${lib_cmakelists_contents}"
    )
    foreach(flag ${flags})
      # Skip reason flags
      if(${flag} MATCHES "REASON")
        continue()
      endif()
      # Skip flags already defined
      if(DEFINED ${flag})
        continue()
      endif()
      # Set flag to off
      set(${flag} OFF PARENT_SCOPE)
    endforeach()
  endif()
endforeach()

# Prevents link errors due to symbol collisions if the same library is linked
# multiple times
list(REMOVE_DUPLICATES ns3-external-libs)

# Build the lib-ns3-static (ns3.x-static-buildtype.a/.lib) with all sublibraries
if(${NS3_STATIC})
  add_library(
    ${lib-ns3-static} STATIC ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                             "${lib-ns3-static-objs}"
  )

  # Replace shared library suffix and check if static version exists before
  # linking
  set(ns3-external-static-libs)
  foreach(sharedlib ${ns3-external-libs})
    if(NOT (${sharedlib} MATCHES ".so"))
      list(APPEND ns3-external-static-libs ${sharedlib})
      continue()
    endif()

    string(REPLACE ".so" ".a" output ${sharedlib})
    if(EXISTS ${output})
      list(APPEND ns3-external-static-libs ${output})
    else()
      message(
        FATAL_ERROR "Static library version of ${sharedlib} was not found"
      )
    endif()
  endforeach()

  # Required by some static libraries, such as sqlite, for some odd reason
  if(LINUX)
    list(APPEND ns3-external-static-libs -ldl)
  endif()

  target_link_libraries(
    ${lib-ns3-static} ${STATIC_LINK_FLAGS} ${LIB_AS_NEEDED_PRE_STATIC}
    ${ns3-external-static-libs} ${LIB_AS_NEEDED_POST_STATIC}
  )
  if(${NS3_CLANG_TIMETRACE})
    add_dependencies(timeTraceReport ${lib-ns3-static})
  endif()
endif()

# Build the lib-ns3 (ns3.x-monolib-buildtype.dll/.dylib/.so) with all
# sublibraries
if(${NS3_MONOLIB})
  add_library(
    ${lib-ns3-monolib} SHARED ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                              "${lib-ns3-static-objs}"
  )
  set_target_properties(
    ${lib-ns3-monolib}
    PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE
               RUNTIME_OUTPUT_DIRECTORY
               ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} # set output directory for DLLs
  )
  target_link_libraries(
    ${lib-ns3-monolib} ${LIB_AS_NEEDED_PRE} ${ns3-external-libs}
    ${LIB_AS_NEEDED_POST}
  )
  if(${NS3_CLANG_TIMETRACE})
    add_dependencies(timeTraceReport ${lib-ns3-monolib})
  endif()
endif()

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  add_dependency_to_optional_modules_dependencies()
endif()

=== ns-3.42/doc/models/Makefile ===
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures

# list all model library .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/organization.rst \
	source/internet-models.rst \
	source/network.rst \
	source/emulation-overview.rst \
	source/traffic-control.rst \
	$(SRC)/antenna/doc/source/antenna.rst \
	$(SRC)/antenna/doc/source/antenna-design.rst \
	$(SRC)/antenna/doc/source/antenna-user.rst \
	$(SRC)/antenna/doc/source/antenna-testing.rst \
	$(SRC)/aodv/doc/aodv.rst \
	$(SRC)/applications/doc/applications.rst \
	$(SRC)/bridge/doc/bridge.rst \
	$(SRC)/brite/doc/brite.rst \
	$(SRC)/buildings/doc/source/buildings.rst \
	$(SRC)/buildings/doc/source/buildings-design.rst \
	$(SRC)/buildings/doc/source/buildings-user.rst \
	$(SRC)/buildings/doc/source/buildings-testing.rst \
	$(SRC)/buildings/doc/source/buildings-references.rst \
	$(SRC)/click/doc/click.rst \
	$(SRC)/csma/doc/csma.rst \
	$(SRC)/dsdv/doc/dsdv.rst \
	$(SRC)/dsr/doc/dsr.rst \
	$(SRC)/mpi/doc/distributed.rst \
	$(SRC)/energy/doc/energy.rst \
	$(SRC)/fd-net-device/doc/fd-net-device.rst \
	$(SRC)/fd-net-device/doc/dpdk-net-device.rst \
	$(SRC)/fd-net-device/doc/netmap-net-device.rst \
	$(SRC)/tap-bridge/doc/tap.rst \
	$(SRC)/mesh/doc/source/mesh.rst \
	$(SRC)/mesh/doc/source/mesh-user.rst \
	$(SRC)/mesh/doc/source/mesh-design.rst \
	$(SRC)/mesh/doc/source/mesh-references.rst \
	$(SRC)/mesh/doc/source/mesh-testing.rst \
	$(SRC)/lte/doc/source/lte.rst \
	$(SRC)/lte/doc/source/lte-user.rst \
	$(SRC)/lte/doc/source/lte-design.rst \
	$(SRC)/lte/doc/source/lte-testing.rst \
	$(SRC)/lte/doc/source/lte-profiling.rst \
	$(SRC)/lte/doc/source/lte-references.rst \
	$(SRC)/propagation/doc/propagation.rst \
	$(SRC)/network/doc/network-overview.rst \
	$(SRC)/network/doc/packets.rst \
	$(SRC)/network/doc/error-model.rst \
	$(SRC)/network/doc/sockets-api.rst \
	$(SRC)/network/doc/simple.rst \
	$(SRC)/network/doc/queue.rst \
	$(SRC)/network/doc/queue-limits.rst \
	$(SRC)/nix-vector-routing/doc/nix-vector-routing.rst \
	$(SRC)/internet/doc/internet-stack.rst \
	$(SRC)/internet/doc/ipv4.rst \
	$(SRC)/internet/doc/ipv6.rst \
	$(SRC)/internet/doc/routing-overview.rst \
	$(SRC)/internet/doc/tcp.rst \
	$(SRC)/internet/doc/udp.rst \
	$(SRC)/internet-apps/doc/internet-apps.rst \
	$(SRC)/mobility/doc/mobility.rst \
	$(SRC)/olsr/doc/olsr.rst \
	$(SRC)/openflow/doc/openflow-switch.rst \
	$(SRC)/point-to-point/doc/point-to-point.rst \
	$(SRC)/wifi/doc/source/wifi.rst \
	$(SRC)/wifi/doc/source/wifi-design.rst \
	$(SRC)/wifi/doc/source/wifi-user.rst \
	$(SRC)/wifi/doc/source/wifi-testing.rst \
	$(SRC)/wifi/doc/source/wifi-changelog.rst \
	$(SRC)/wifi/doc/source/wifi-references.rst \
	$(SRC)/wimax/doc/wimax.rst \
	$(SRC)/uan/doc/uan.rst \
	$(SRC)/topology-read/doc/topology.rst \
	$(SRC)/traffic-control/doc/traffic-control-layer.rst \
	$(SRC)/traffic-control/doc/queue-discs.rst \
	$(SRC)/traffic-control/doc/pfifo-fast.rst \
	$(SRC)/traffic-control/doc/fifo.rst \
	$(SRC)/traffic-control/doc/prio.rst \
	$(SRC)/traffic-control/doc/tbf.rst \
	$(SRC)/traffic-control/doc/red.rst \
	$(SRC)/traffic-control/doc/codel.rst \
	$(SRC)/traffic-control/doc/cobalt.rst \
	$(SRC)/traffic-control/doc/fq-codel.rst \
	$(SRC)/traffic-control/doc/fq-cobalt.rst \
	$(SRC)/traffic-control/doc/pie.rst \
	$(SRC)/traffic-control/doc/fq-pie.rst \
	$(SRC)/traffic-control/doc/mq.rst \
	$(SRC)/spectrum/doc/spectrum.rst \
	$(SRC)/netanim/doc/animation.rst \
	$(SRC)/flow-monitor/doc/flow-monitor.rst \
	$(SRC)/sixlowpan/doc/sixlowpan.rst \
	$(SRC)/lr-wpan/doc/lr-wpan.rst \

# list all model library figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) both a .pdf and .png file
SOURCEFIGS = \
	figures/testbed.dia \
	figures/emulated-channel.dia \
	$(SRC)/antenna/doc/source/figures/antenna-coordinate-system.dia	\
	$(SRC)/antenna/doc/source/figures/circular-antenna-pattern.png	\
	$(SRC)/applications/doc/http-embedded-object-size.png \
	$(SRC)/applications/doc/http-main-object-size.png \
	$(SRC)/applications/doc/http-num-of-embedded-objects.png \
	$(SRC)/applications/doc/http-parsing-time.png \
	$(SRC)/applications/doc/http-reading-time.png \
	$(SRC)/network/doc/packet.dia \
	$(SRC)/network/doc/node.dia \
	$(SRC)/network/doc/buffer.dia \
	$(SRC)/network/doc/sockets-overview.dia \
	$(SRC)/internet/doc/internet-node-send.dia \
	$(SRC)/internet/doc/internet-node-recv.dia \
	$(SRC)/internet/doc/routing.dia \
	$(SRC)/internet/doc/routing-specialization.dia \
	$(SRC)/internet/doc/figures/tcp-state-machine.png \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-new-reno.png \
	$(SRC)/internet/doc/figures/ns3-new-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/ns3-bbr-vs-linux-bbr.png \
	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/wifi-phy-rx-trace-helper.dia \
	$(SRC)/wifi/doc/source/figures/snir.dia \
	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
	$(SRC)/wifi/doc/source/figures/assoc-manager.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-dl-txop.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-ul-txop.eps \
	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/mu-bar.png \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.png \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.pdf \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.png \
	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ac.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ax.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11a-p-1500-adhoc-r-54-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/default-table-based-error-model-validation.eps \
	$(SRC)/wifi/doc/source/figures/error-models-comparison.eps \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.png \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.png \
	$(SRC)/wimax/doc/WimaxArchitecture.dia \
	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/epc-topology.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-x2-enhanced.dia \
	$(SRC)/lte/doc/source/figures/eutran-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/ff-example.dia \
	$(SRC)/lte/doc/source/figures/ff-mac-saps.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-enb-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-ue-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-handover-seq-diagram.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-control-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-interference-test-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-subframe-structure.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-interface.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-architecture.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-processes-scheme.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-consumer.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-motion.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1-hys.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-timeline.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-handover-target-scenario.dia \
	$(SRC)/lte/doc/source/figures/lena-dual-stripe.eps \
	$(SRC)/lte/doc/source/figures/lte-mcs-index.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase1.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase2.eps \
	$(SRC)/lte/doc/source/figures/runningTime10s.eps \
	$(SRC)/lte/doc/source/figures/epcRunningTime.eps \
	$(SRC)/lte/doc/source/figures/propagationModel.eps \
	$(SRC)/lte/doc/source/figures/simulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcSimulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcEutranRunningTime.eps \
	$(SRC)/lte/doc/source/figures/profiling-memory.eps \
	$(SRC)/lte/doc/source/figures/lte-rlc-implementation-model.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-entity-saps.dia \
	$(SRC)/lte/doc/source/figures/ca-rrc-reconf.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-enb-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-ue-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/lte-strongest-cell-handover-algorithm.eps \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.pdf \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.png \
	$(SRC)/lte/doc/source/figures/helpers.pdf \
	$(SRC)/lte/doc/source/figures/helpers.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.pdf \

=== ns-3.42/src/core/CMakeLists.txt ===
# Set lib core link dependencies
set(libraries_to_link)

set(gsl_test_sources)
if(${GSL_FOUND})
  set(libraries_to_link
      ${libraries_to_link}
      ${GSL_LIBRARIES}
  )
  set(gsl_test_sources
      test/rng-test-suite.cc
      test/random-variable-stream-test-suite.cc
  )
endif()

# Check for dependencies and add sources accordingly
check_include_files(
  "boost/units/quantity.hpp;boost/units/systems/si.hpp"
  HAVE_BOOST_UNITS
  LANGUAGE
  CXX
)

if(${HAVE_BOOST_UNITS})
  add_definitions(
    -DHAVE_BOOST
    -DHAVE_BOOST_UNITS
  )
  message(STATUS "Boost Units have been found.")
else()
  message(
    STATUS
      "Boost Units are an optional feature of length.cc."
      " Ubuntu ships it within the libboost-dev package."
      " You may need to clean up the CMake cache after installing it to pass this check."
  )
endif()

set(int64x64_sources)
set(int64x64_headers)

if(${NS3_INT64X64}
   MATCHES
   "INT128"
)
  set(int64x64_sources
      model/int64x64-128.cc
  )
  set(int64x64_headers
      model/int64x64-128.h
  )
elseif(
  ${NS3_INT64X64}
  MATCHES
  "DOUBLE"
)
  set(int64x64_headers
      model/int64x64-double.h
  )
elseif(
  ${NS3_INT64X64}
  MATCHES
  "CAIRO"
)
  set(int64x64_sources
      model/int64x64-cairo.cc
  )
  set(int64x64_headers
      model/int64x64-cairo.h
      model/cairo-wideint-private.h
  )
endif()

set(example_as_test_sources)
set(example_as_test_headers)
set(example_as_test_suite)
if(${ENABLE_EXAMPLES})
  set(example_as_test_sources
      model/example-as-test.cc
  )
  set(example_as_test_headers
      model/example-as-test.h
  )
  set(example_as_test_suite
      test/examples-as-tests-test-suite.cc
  )
endif()

# Embedded version support
set(embedded_version_sources)
set(embedded_version_headers)
if(${ENABLE_BUILD_VERSION})
  set(embedded_version_sources
      model/version.cc
  )
  set(embedded_version_headers
      model/version.h
  )
endif()

if(WIN32)
  set(libraries_to_link
      ${libraries_to_link}
      wsock32
      ws2_32
  )
  set(fd-reader-sources
      model/win32-fd-reader.cc
  )
else()
  set(fd-reader-sources
      model/unix-fd-reader.cc
  )
endif()

# Define core lib sources
set(source_files
    ${int64x64_sources}
    ${fd-reader-sources}
    ${example_as_test_sources}
    ${embedded_version_sources}
    helper/csv-reader.cc
    helper/random-variable-stream-helper.cc
    helper/event-garbage-collector.cc
    model/time.cc
    model/event-id.cc
    model/scheduler.cc
    model/list-scheduler.cc
    model/map-scheduler.cc
    model/heap-scheduler.cc
    model/calendar-scheduler.cc
    model/priority-queue-scheduler.cc
    model/event-impl.cc
    model/simulator.cc
    model/simulator-impl.cc
    model/default-simulator-impl.cc
    model/timer.cc
    model/watchdog.cc
    model/synchronizer.cc
    model/environment-variable.cc
    model/log.cc
    model/breakpoint.cc
    model/type-id.cc
    model/attribute-construction-list.cc
    model/object-base.cc
    model/object.cc
    model/test.cc
    model/random-variable-stream.cc
    model/rng-seed-manager.cc
    model/rng-stream.cc
    model/command-line.cc
    model/attribute.cc
    model/boolean.cc
    model/integer.cc
    model/uinteger.cc
    model/double.cc
    model/int64x64.cc
    model/string.cc
    model/pointer.cc
    model/object-ptr-container.cc
    model/object-factory.cc
    model/global-value.cc
    model/trace-source-accessor.cc
    model/config.cc
    model/callback.cc
    model/names.cc
    model/vector.cc
    model/fatal-impl.cc
    model/system-path.cc
    model/hash-function.cc
    model/hash-murmur3.cc
    model/hash-fnv.cc
    model/hash.cc
    model/des-metrics.cc
    model/ascii-file.cc
    model/node-printer.cc
    model/show-progress.cc
    model/time-printer.cc
    model/system-wall-clock-ms.cc
    model/system-wall-clock-timestamp.cc
    model/length.cc
    model/trickle-timer.cc
    model/realtime-simulator-impl.cc
    model/wall-clock-synchronizer.cc
    model/matrix-array.cc
)

# Define core lib headers
set(header_files
    ${int64x64_headers}
    ${example_as_test_headers}
    ${embedded_version_headers}
    helper/csv-reader.h
    helper/event-garbage-collector.h
    helper/random-variable-stream-helper.h
    model/abort.h
    model/ascii-file.h
    model/ascii-test.h
    model/assert.h
    model/attribute-accessor-helper.h
    model/attribute-construction-list.h
    model/attribute-container.h
    model/attribute-helper.h
    model/attribute.h
    model/boolean.h
    model/breakpoint.h
    model/build-profile.h
    model/calendar-scheduler.h
    model/callback.h
    model/command-line.h
    model/config.h
    model/default-deleter.h
    model/default-simulator-impl.h
    model/deprecated.h
    model/des-metrics.h
    model/double.h
    model/enum.h
    model/event-id.h
    model/event-impl.h
    model/fatal-error.h
    model/fatal-impl.h
    model/fd-reader.h
    model/environment-variable.h
    model/global-value.h
    model/hash-fnv.h
    model/hash-function.h
    model/hash-murmur3.h
    model/hash.h
    model/heap-scheduler.h
    model/int64x64-double.h
    model/int64x64.h
    model/integer.h
    model/length.h
    model/list-scheduler.h
    model/log-macros-disabled.h
    model/log-macros-enabled.h
    model/log.h
    model/make-event.h
    model/map-scheduler.h
    model/math.h
    model/names.h
    model/node-printer.h
    model/nstime.h
    model/object-base.h
    model/object-factory.h
    model/object-map.h
    model/object-ptr-container.h
    model/object-vector.h
    model/object.h
    model/pair.h
    model/pointer.h
    model/priority-queue-scheduler.h
    model/ptr.h
    model/random-variable-stream.h
    model/rng-seed-manager.h
    model/rng-stream.h
    model/scheduler.h
    model/show-progress.h
    model/shuffle.h
    model/simple-ref-count.h
    model/simulation-singleton.h
    model/simulator-impl.h
    model/simulator.h
    model/singleton.h
    model/string.h
    model/synchronizer.h
    model/system-path.h
    model/system-wall-clock-ms.h
    model/system-wall-clock-timestamp.h
    model/test.h
    model/time-printer.h
    model/timer-impl.h
    model/timer.h
    model/trace-source-accessor.h
    model/traced-callback.h
    model/traced-value.h
    model/trickle-timer.h
    model/tuple.h
    model/type-id.h
    model/type-name.h
    model/type-traits.h
    model/uinteger.h
    model/uniform-random-bit-generator.h
    model/valgrind.h
    model/vector.h
    model/warnings.h
    model/watchdog.h
    model/realtime-simulator-impl.h
    model/wall-clock-synchronizer.h
    model/val-array.h
    model/matrix-array.h
)

set(test_sources
    ${example_as_test_suite}
    ${gsl_test_sources}
    test/attribute-container-test-suite.cc
    test/attribute-test-suite.cc
    test/build-profile-test-suite.cc
    test/callback-test-suite.cc
    test/command-line-test-suite.cc
    test/config-test-suite.cc
    test/environment-variable-test-suite.cc
    test/event-garbage-collector-test-suite.cc
    test/global-value-test-suite.cc
    test/hash-test-suite.cc
    test/int64x64-test-suite.cc
    test/length-test-suite.cc
    test/many-uniform-random-variables-one-get-value-call-test-suite.cc
    test/names-test-suite.cc
    test/object-test-suite.cc
    test/one-uniform-random-variable-many-get-value-calls-test-suite.cc
    test/pair-value-test-suite.cc
    test/ptr-test-suite.cc
    test/sample-test-suite.cc
    test/simulator-test-suite.cc
    test/splitstring-test-suite.cc
    test/threaded-test-suite.cc
    test/time-test-suite.cc
    test/timer-test-suite.cc
    test/traced-callback-test-suite.cc
    test/trickle-timer-test-suite.cc
    test/tuple-value-test-suite.cc
    test/type-id-test-suite.cc
    test/type-traits-test-suite.cc
    test/watchdog-test-suite.cc
    test/val-array-test-suite.cc
    test/matrix-array-test-suite.cc
)

# Build core lib
build_lib(
  LIBNAME core
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK ${libraries_to_link}
  TEST_SOURCES ${test_sources}
)

=== ns-3.42/src/wifi/CMakeLists.txt ===
set(gsl_libraries)
if(${GSL_FOUND})
  set(gsl_libraries
      ${GSL_LIBRARIES}
  )
endif()

set(source_files
    helper/athstats-helper.cc
    helper/spectrum-wifi-helper.cc
    helper/wifi-helper.cc
    helper/wifi-mac-helper.cc
    helper/wifi-radio-energy-model-helper.cc
    helper/yans-wifi-helper.cc
    helper/wifi-phy-rx-trace-helper.cc
    model/addba-extension.cc
    model/adhoc-wifi-mac.cc
    model/ampdu-subframe-header.cc
    model/ampdu-tag.cc
    model/amsdu-subframe-header.cc
    model/ap-wifi-mac.cc
    model/block-ack-agreement.cc
    model/block-ack-manager.cc
    model/block-ack-type.cc
    model/block-ack-window.cc
    model/capability-information.cc
    model/channel-access-manager.cc
    model/ctrl-headers.cc
    model/edca-parameter-set.cc
    model/eht/default-emlsr-manager.cc
    model/eht/eht-capabilities.cc
    model/eht/eht-configuration.cc
    model/eht/eht-frame-exchange-manager.cc
    model/eht/eht-operation.cc
    model/eht/tid-to-link-mapping-element.cc
    model/eht/eht-phy.cc
    model/eht/eht-ppdu.cc
    model/eht/emlsr-manager.cc
    model/eht/multi-link-element.cc
    model/error-rate-model.cc
    model/extended-capabilities.cc
    model/fcfs-wifi-queue-scheduler.cc
    model/frame-capture-model.cc
    model/frame-exchange-manager.cc
    model/he/constant-obss-pd-algorithm.cc
    model/he/he-6ghz-band-capabilities.cc
    model/he/he-capabilities.cc
    model/he/he-configuration.cc
    model/he/he-frame-exchange-manager.cc
    model/he/he-operation.cc
    model/he/he-phy.cc
    model/he/he-ppdu.cc
    model/he/he-ru.cc
    model/he/mu-edca-parameter-set.cc
    model/he/mu-snr-tag.cc
    model/he/multi-user-scheduler.cc
    model/he/obss-pd-algorithm.cc
    model/he/rr-multi-user-scheduler.cc
    model/ht/ht-capabilities.cc
    model/ht/ht-configuration.cc
    model/ht/ht-frame-exchange-manager.cc
    model/ht/ht-operation.cc
    model/ht/ht-phy.cc
    model/ht/ht-ppdu.cc
    model/interference-helper.cc
    model/mac-rx-middle.cc
    model/mac-tx-middle.cc
    model/mgt-action-headers.cc
    model/mgt-headers.cc
    model/mpdu-aggregator.cc
    model/msdu-aggregator.cc
    model/nist-error-rate-model.cc
    model/non-ht/dsss-error-rate-model.cc
    model/non-ht/dsss-parameter-set.cc
    model/non-ht/dsss-phy.cc
    model/non-ht/dsss-ppdu.cc
    model/non-ht/erp-information.cc
    model/non-ht/erp-ofdm-phy.cc
    model/non-ht/erp-ofdm-ppdu.cc
    model/non-ht/ofdm-phy.cc
    model/non-ht/ofdm-ppdu.cc
    model/non-inheritance.cc
    model/originator-block-ack-agreement.cc
    model/phy-entity.cc
    model/preamble-detection-model.cc
    model/qos-frame-exchange-manager.cc
    model/qos-txop.cc
    model/qos-utils.cc
    model/rate-control/aarf-wifi-manager.cc
    model/rate-control/aarfcd-wifi-manager.cc
    model/rate-control/amrr-wifi-manager.cc
    model/rate-control/aparf-wifi-manager.cc
    model/rate-control/arf-wifi-manager.cc
    model/rate-control/cara-wifi-manager.cc
    model/rate-control/constant-rate-wifi-manager.cc
    model/rate-control/ideal-wifi-manager.cc
    model/rate-control/minstrel-ht-wifi-manager.cc
    model/rate-control/minstrel-wifi-manager.cc
    model/rate-control/onoe-wifi-manager.cc
    model/rate-control/parf-wifi-manager.cc
    model/rate-control/rraa-wifi-manager.cc
    model/rate-control/rrpaa-wifi-manager.cc
    model/rate-control/thompson-sampling-wifi-manager.cc
    model/recipient-block-ack-agreement.cc
    model/reduced-neighbor-report.cc
    model/reference/error-rate-tables.cc
    model/simple-frame-capture-model.cc
    model/snr-tag.cc
    model/spectrum-wifi-phy.cc
    model/ssid.cc
    model/sta-wifi-mac.cc
    model/status-code.cc
    model/supported-rates.cc
    model/table-based-error-rate-model.cc
    model/threshold-preamble-detection-model.cc
    model/tim.cc
    model/txop.cc
    model/vht/vht-capabilities.cc
    model/vht/vht-configuration.cc
    model/vht/vht-frame-exchange-manager.cc
    model/vht/vht-operation.cc
    model/vht/vht-phy.cc
    model/vht/vht-ppdu.cc
    model/wifi-ack-manager.cc
    model/wifi-acknowledgment.cc
    model/wifi-assoc-manager.cc
    model/wifi-bandwidth-filter.cc
    model/wifi-default-ack-manager.cc
    model/wifi-default-assoc-manager.cc
    model/wifi-default-protection-manager.cc
    model/wifi-information-element.cc
    model/wifi-mac-header.cc
    model/wifi-mac-queue-container.cc
    model/wifi-mac-queue-elem.cc
    model/wifi-mac-queue-scheduler.cc
    model/wifi-mac-queue.cc
    model/wifi-mac-trailer.cc
    model/wifi-mac.cc
    model/wifi-mode.cc
    model/wifi-mpdu.cc
    model/wifi-net-device.cc
    model/wifi-phy.cc
    model/wifi-phy-common.cc
    model/wifi-phy-operating-channel.cc
    model/wifi-phy-state-helper.cc
    model/wifi-ppdu.cc
    model/wifi-protection-manager.cc
    model/wifi-protection.cc
    model/wifi-psdu.cc
    model/wifi-radio-energy-model.cc
    model/wifi-remote-station-info.cc
    model/wifi-remote-station-manager.cc
    model/wifi-spectrum-phy-interface.cc
    model/wifi-spectrum-signal-parameters.cc
    model/wifi-standards.cc
    model/wifi-tx-current-model.cc
    model/wifi-tx-parameters.cc
    model/wifi-tx-timer.cc
    model/wifi-tx-vector.cc
    model/wifi-utils.cc
    model/yans-error-rate-model.cc
    model/yans-wifi-channel.cc
    model/yans-wifi-phy.cc
    model/wifi-spectrum-value-helper.cc
)

set(header_files
    helper/athstats-helper.h
    helper/spectrum-wifi-helper.h
    helper/wifi-helper.h
    helper/wifi-mac-helper.h
    helper/wifi-radio-energy-model-helper.h
    helper/yans-wifi-helper.h
    helper/wifi-phy-rx-trace-helper.h
    model/addba-extension.h
    model/adhoc-wifi-mac.h
    model/ampdu-subframe-header.h
    model/ampdu-tag.h
    model/amsdu-subframe-header.h
    model/ap-wifi-mac.h
    model/block-ack-agreement.h
    model/block-ack-manager.h
    model/block-ack-type.h
    model/block-ack-window.h
    model/capability-information.h
    model/channel-access-manager.h
    model/ctrl-headers.h
    model/edca-parameter-set.h
    model/eht/default-emlsr-manager.h
    model/eht/eht-capabilities.h
    model/eht/eht-configuration.h
    model/eht/eht-frame-exchange-manager.h
    model/eht/eht-operation.h
    model/eht/tid-to-link-mapping-element.h
    model/eht/eht-phy.h
    model/eht/eht-ppdu.h
    model/eht/emlsr-manager.h
    model/eht/multi-link-element.h
    model/error-rate-model.h
    model/extended-capabilities.h
    model/fcfs-wifi-queue-scheduler.h
    model/frame-capture-model.h
    model/frame-exchange-manager.h
    model/he/constant-obss-pd-algorithm.h
    model/he/he-6ghz-band-capabilities.h
    model/he/he-capabilities.h
    model/he/he-configuration.h
    model/he/he-frame-exchange-manager.h
    model/he/he-operation.h
    model/he/he-phy.h
    model/he/he-ppdu.h
    model/he/he-ru.h
    model/he/mu-edca-parameter-set.h
    model/he/mu-snr-tag.h
    model/he/multi-user-scheduler.h
    model/he/obss-pd-algorithm.h
    model/he/rr-multi-user-scheduler.h
    model/ht/ht-capabilities.h
    model/ht/ht-configuration.h
    model/ht/ht-frame-exchange-manager.h
    model/ht/ht-operation.h
    model/ht/ht-phy.h
    model/ht/ht-ppdu.h
    model/interference-helper.h
    model/mac-rx-middle.h
    model/mac-tx-middle.h
    model/mgt-action-headers.h
    model/mgt-headers.h
    model/mpdu-aggregator.h
    model/msdu-aggregator.h
    model/nist-error-rate-model.h
    model/non-ht/dsss-error-rate-model.h
    model/non-ht/dsss-parameter-set.h
    model/non-ht/dsss-phy.h
    model/non-ht/dsss-ppdu.h
    model/non-ht/erp-information.h
    model/non-ht/erp-ofdm-phy.h
    model/non-ht/erp-ofdm-ppdu.h
    model/non-ht/ofdm-phy.h
    model/non-ht/ofdm-ppdu.h
    model/non-inheritance.h
    model/originator-block-ack-agreement.h
    model/phy-entity.h
    model/preamble-detection-model.h
    model/qos-frame-exchange-manager.h
    model/qos-txop.h
    model/qos-utils.h
    model/rate-control/aarf-wifi-manager.h
    model/rate-control/aarfcd-wifi-manager.h
    model/rate-control/amrr-wifi-manager.h
    model/rate-control/aparf-wifi-manager.h
    model/rate-control/arf-wifi-manager.h
    model/rate-control/cara-wifi-manager.h
    model/rate-control/constant-rate-wifi-manager.h
    model/rate-control/ideal-wifi-manager.h
    model/rate-control/minstrel-ht-wifi-manager.h
    model/rate-control/minstrel-wifi-manager.h
    model/rate-control/onoe-wifi-manager.h
    model/rate-control/parf-wifi-manager.h
    model/rate-control/rraa-wifi-manager.h
    model/rate-control/rrpaa-wifi-manager.h
    model/rate-control/thompson-sampling-wifi-manager.h
    model/recipient-block-ack-agreement.h
    model/reduced-neighbor-report.h
    model/reference/error-rate-tables.h
    model/simple-frame-capture-model.h
    model/snr-tag.h
    model/spectrum-wifi-phy.h
    model/ssid.h
    model/sta-wifi-mac.h
    model/status-code.h
    model/supported-rates.h
    model/table-based-error-rate-model.h
    model/threshold-preamble-detection-model.h
    model/tim.h
    model/txop.h
    model/vht/vht-capabilities.h
    model/vht/vht-configuration.h
    model/vht/vht-frame-exchange-manager.h
    model/vht/vht-operation.h
    model/vht/vht-phy.h
    model/vht/vht-ppdu.h
    model/wifi-ack-manager.h
    model/wifi-acknowledgment.h
    model/wifi-assoc-manager.h
    model/wifi-bandwidth-filter.h
    model/wifi-default-ack-manager.h
    model/wifi-default-assoc-manager.h
    model/wifi-default-protection-manager.h
    model/wifi-information-element.h
    model/wifi-mac-header.h
    model/wifi-mac-queue-container.h
    model/wifi-mac-queue-elem.h
    model/wifi-mac-queue-scheduler-impl.h
    model/wifi-mac-queue-scheduler.h
    model/wifi-mac-queue.h
    model/wifi-mac-trailer.h
    model/wifi-mac.h
    model/wifi-mgt-header.h
    model/wifi-mode.h
    model/wifi-mpdu-type.h
    model/wifi-mpdu.h
    model/wifi-net-device.h
    model/wifi-opt-field.h
    model/wifi-phy-band.h
    model/wifi-phy-common.h
    model/wifi-phy-listener.h
    model/wifi-phy-operating-channel.h
    model/wifi-phy-state-helper.h
    model/wifi-phy-state.h
    model/wifi-phy.h
    model/wifi-ppdu.h
    model/wifi-protection-manager.h
    model/wifi-protection.h
    model/wifi-psdu.h
    model/wifi-radio-energy-model.h
    model/wifi-remote-station-info.h
    model/wifi-remote-station-manager.h
    model/wifi-spectrum-phy-interface.h
    model/wifi-spectrum-signal-parameters.h
    model/wifi-standards.h
    model/wifi-tx-current-model.h
    model/wifi-tx-parameters.h
    model/wifi-tx-timer.h
    model/wifi-tx-vector.h
    model/wifi-utils.h
    model/yans-error-rate-model.h
    model/yans-wifi-channel.h
    model/yans-wifi-phy.h
    model/wifi-spectrum-value-helper.h
)

build_lib(
  LIBNAME wifi
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK
    ${libenergy}
    ${libspectrum}
    ${gsl_libraries}
  TEST_SOURCES
    test/block-ack-test-suite.cc
    test/channel-access-manager-test.cc
    test/inter-bss-test-suite.cc
    test/power-rate-adaptation-test.cc
    test/power-save-test.cc
    test/spectrum-wifi-phy-test.cc
    test/tx-duration-test.cc
    test/wifi-aggregation-test.cc
    test/wifi-dynamic-bw-op-test.cc
    test/wifi-eht-info-elems-test.cc
    test/wifi-emlsr-test.cc
    test/wifi-error-rate-models-test.cc
    test/wifi-fils-frame-test.cc
    test/wifi-he-info-elems-test.cc
    test/wifi-ie-fragment-test.cc
    test/wifi-mac-ofdma-test.cc
    test/wifi-mac-queue-test.cc
    test/wifi-mlo-test.cc
    test/wifi-phy-ofdma-test.cc
    test/wifi-phy-reception-test.cc
    test/wifi-phy-rx-trace-helper-test.cc
    test/wifi-phy-thresholds-test.cc
    test/wifi-primary-channels-test.cc
    test/wifi-ru-allocation-test.cc
    test/wifi-channel-switching-test.cc
    test/wifi-test.cc
    test/wifi-transmit-mask-test.cc
    test/wifi-txop-test.cc
    test/wifi-phy-cca-test.cc
    test/wifi-non-ht-dup-test.cc
    test/wifi-phy-mu-mimo-test.cc
)

=== ns-3.42/src/lr-wpan/examples/CMakeLists.txt ===
set(base_examples
    lr-wpan-data
    lr-wpan-mlme
    lr-wpan-packet-print
    lr-wpan-phy-test
    lr-wpan-ed-scan
    lr-wpan-active-scan
    lr-wpan-orphan-scan
)

foreach(
  example
  ${base_examples}
)
  build_lib_example(
    NAME ${example}
    SOURCE_FILES ${example}.cc
    LIBRARIES_TO_LINK ${liblr-wpan}
  )
endforeach()

build_lib_example(
  NAME lr-wpan-error-distance-plot
  SOURCE_FILES lr-wpan-error-distance-plot.cc
  LIBRARIES_TO_LINK ${liblr-wpan}
                    ${libstats}
)

build_lib_example(
  NAME lr-wpan-error-model-plot
  SOURCE_FILES lr-wpan-error-model-plot.cc
  LIBRARIES_TO_LINK ${liblr-wpan}
                    ${libstats}
)

build_lib_example(
  NAME lr-wpan-bootstrap
  SOURCE_FILES lr-wpan-bootstrap.cc
  LIBRARIES_TO_LINK ${liblr-wpan}
                    ${libnetanim}
)

build_lib_example(
  NAME lr-wpan-per-plot
  SOURCE_FILES lr-wpan-per-plot.cc
  LIBRARIES_TO_LINK ${liblr-wpan}
                    ${libstats}
)

=== debian/changelog ===
ns3 (3.42-2) unstable; urgency=medium

  * Realy upload to unstable now that it went through NEW.

 -- Martin Quinson <mquinson@debian.org>  Fri, 21 Jun 2024 22:21:20 +0200

ns3 (3.42-1) experimental; urgency=medium

  * New upstream release.
  * Acknoledge the NMU. Thanks Steve!

 -- Martin Quinson <mquinson@debian.org>  Sun, 16 Jun 2024 00:32:51 +0200

ns3 (3.41-1.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Sun, 25 Feb 2024 08:40:43 +0000

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.6.2
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: YunQiang Su <syq@debian.org>
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-exec (>= 0.13),
 dh-python,
 dpkg (>= 1.16.1),
 flex,
 jdupes,
 libboost-filesystem-dev,
 libgsl-dev,
 libsqlite3-dev,
 libxml2-dev,
 pkg-config,
 python3-dev,
 gir1.2-goocanvas-2.0,
 python3-gi,
 python3-gi-cairo,
 python3-pygraphviz,
 gir1.2-gtk-3.0,
Build-Depends-Indep:
 libgraphviz-dev,
 quilt (>= 0.46-7~),
 ipython3,
 dia,
 doxygen,
 dvipng,
 ghostscript,
 imagemagick,
 latexmk,
 python3-sphinx,
 tex-gyre,
 texlive-font-utils,
 texlive-latex-extra,
 texlive-latex-base,
 texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: https://www.nsnam.org/
Vcs-Git: https://salsa.debian.org/debian/ns3.git

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python3-ns3.

Package: ns3-doc
Architecture: all
Build-Profiles: <!nodoc>
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery, libjs-sphinxdoc
Section: doc
Description: documentation for ns3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains manual, modules, tutorial and doxygen.

# Note to self: when updating this, you also need to update the SONAME in the relevant patch
Package: libns3.42
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains shared libraries.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libns3.42 (= ${binary:Version}),
  g++,
Breaks: ns3 (= 3.25+dfsg2-2)
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains static libraries, header files.

#Package: python3-ns3
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
#  python3-pygraphviz
#Section: python
#Suggests: tcpdump
#Breaks: python-ns3
#Description: Python binding of ns3
# ns-3 is a discrete-event network simulator for Internet systems,
# targeted primarily for research and educational use.
# ns-3 is free software, licensed under the GNU GPLv2 license,
# and is publicly available for research, development, and use.
# ns-3 is intended as an eventual replacement for the popular
# ns-2 simulator. The project acronym “nsnam” derives
# historically from the concatenation of ns (network simulator)
# and NAM (network animator).
# .
# This package contains Python binding of ns3.
